<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:24 CEST 2019 -->
<title>XdrOutputStream (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="XdrOutputStream (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrInputStream.html" title="class in org.firebirdsql.gds.impl.wire"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/impl/wire/XdrOutputStream.html" target="_top">Frames</a></li>
<li><a href="XdrOutputStream.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.impl.wire</div>
<h2 title="Class XdrOutputStream" class="title">Class XdrOutputStream</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">java.io.OutputStream</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.impl.wire.XdrOutputStream</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io">Closeable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/io/Flushable.html?is-external=true" title="class or interface in java.io">Flushable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></dd>
</dl>
<hr>
<br>
<pre>public final class <span class="typeNameLabel">XdrOutputStream</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></pre>
<div class="block">An <code>XdrOutputStream</code> writes data in XDR format to an
 underlying <code>java.io.OutputStream</code>.
 <p>
 This class is not thread-safe.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>1.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:alberola@users.sourceforge.net">Alejandro Alberola</a>, <a href="mailto:d_jencks@users.sourceforge.net">David Jencks</a>, <a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#NULL_BYTE">NULL_BYTE</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#SPACE_BYTE">SPACE_BYTE</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#XdrOutputStream-java.io.OutputStream-">XdrOutputStream</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a>&nbsp;out)</code>
<div class="block">Create a new instance of <code>XdrOutputStream</code> with buffering.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#XdrOutputStream-java.io.OutputStream-boolean-">XdrOutputStream</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a>&nbsp;out,
               boolean&nbsp;buffered)</code>
<div class="block">Create a new instance of <code>XdrOutputStream</code> with either a buffered or an unbuffered stream.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#close--">close</a></span>()</code>
<div class="block">Close this stream and the underlying output stream.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#flush--">flush</a></span>()</code>
<div class="block">Flush all buffered data to the underlying output stream.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#setCipher-javax.crypto.Cipher-">setCipher</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/crypto/Cipher.html?is-external=true" title="class or interface in javax.crypto">Cipher</a>&nbsp;cipher)</code>&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#write-byte:A-int-int-">write</a></span>(byte[]&nbsp;b,
     int&nbsp;off,
     int&nbsp;len)</code>
<div class="block">Writes <code>len</code> bytes from the specified byte array
 starting at offset <code>off</code> to this output stream as defined by <a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#write-byte:A-int-int-" title="class or interface in java.io"><code>OutputStream.write(byte[], int, int)</code></a>.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#write-byte:A-int-int-int-">write</a></span>(byte[]&nbsp;b,
     int&nbsp;offset,
     int&nbsp;len,
     int&nbsp;pad)</code>
<div class="block">Write a <code>byte</code> buffer to the underlying output stream
 in XDR format.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#write-int-">write</a></span>(int&nbsp;b)</code>
<div class="block">Write a single <code>byte</code> to the underlying output stream in
 XDR format.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeAlignment-int-">writeAlignment</a></span>(int&nbsp;length)</code>
<div class="block">Writes the <code>0x00</code> alignment for the specified length.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeBuffer-byte:A-">writeBuffer</a></span>(byte[]&nbsp;buffer)</code>
<div class="block">Write a <code>byte</code> buffer to the underlying output stream in
 XDR format.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeDirect-byte:A-">writeDirect</a></span>(byte[]&nbsp;data)</code>
<div class="block">Writes directly to the <code>OutputStream</code> of the underlying socket.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeInt-int-">writeInt</a></span>(int&nbsp;v)</code>
<div class="block">Write an <code>int</code> value to the underlying stream in XDR format.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeLong-long-">writeLong</a></span>(long&nbsp;v)</code>
<div class="block">Write a <code>long</code> value to the underlying stream in XDR format.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writePadding-int-int-">writePadding</a></span>(int&nbsp;length,
            int&nbsp;padByte)</code>
<div class="block">Writes padding for the specified length of the specified padding byte.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeSpacePadding-int-">writeSpacePadding</a></span>(int&nbsp;length)</code>
<div class="block">Writes space (<code>0x20</code>) padding of the specified length</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeString-java.lang.String-org.firebirdsql.encodings.Encoding-">writeString</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;s,
           <a href="../../../../../org/firebirdsql/encodings/Encoding.html" title="interface in org.firebirdsql.encodings">Encoding</a>&nbsp;encoding)</code>
<div class="block">Write content of the specified string using the specified encoding.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeTyped-int-org.firebirdsql.gds.impl.wire.Xdrable-">writeTyped</a></span>(int&nbsp;type,
          <a href="../../../../../org/firebirdsql/gds/impl/wire/Xdrable.html" title="interface in org.firebirdsql.gds.impl.wire">Xdrable</a>&nbsp;item)</code>
<div class="block">Write an <code>Xdrable</code> to this output stream.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeTyped-org.firebirdsql.gds.ParameterBuffer-">writeTyped</a></span>(<a href="../../../../../org/firebirdsql/gds/ParameterBuffer.html" title="interface in org.firebirdsql.gds">ParameterBuffer</a>&nbsp;parameterBuffer)</code>&nbsp;</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeZeroPadding-int-">writeZeroPadding</a></span>(int&nbsp;length)</code>
<div class="block">Writes zero padding of the specified length</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.io.OutputStream">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.io.<a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#write-byte:A-" title="class or interface in java.io">write</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="SPACE_BYTE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>SPACE_BYTE</h4>
<pre>public static final&nbsp;int SPACE_BYTE</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../constant-values.html#org.firebirdsql.gds.impl.wire.XdrOutputStream.SPACE_BYTE">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="NULL_BYTE">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>NULL_BYTE</h4>
<pre>public static final&nbsp;int NULL_BYTE</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../constant-values.html#org.firebirdsql.gds.impl.wire.XdrOutputStream.NULL_BYTE">Constant Field Values</a></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="XdrOutputStream-java.io.OutputStream-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>XdrOutputStream</h4>
<pre>public&nbsp;XdrOutputStream(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a>&nbsp;out)</pre>
<div class="block">Create a new instance of <code>XdrOutputStream</code> with buffering.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>out</code> - The underlying <code>OutputStream</code> to write to</dd>
</dl>
</li>
</ul>
<a name="XdrOutputStream-java.io.OutputStream-boolean-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>XdrOutputStream</h4>
<pre>public&nbsp;XdrOutputStream(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a>&nbsp;out,
                       boolean&nbsp;buffered)</pre>
<div class="block">Create a new instance of <code>XdrOutputStream</code> with either a buffered or an unbuffered stream.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>out</code> - The underlying <code>OutputStream</code> to write to</dd>
<dd><code>buffered</code> - <code>true</code> Uses buffering (like <a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#XdrOutputStream-java.io.OutputStream-"><code>XdrOutputStream(java.io.OutputStream)</code></a> or
         <code>false</code> writes directly to provided <code>OutputStream</code>.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="writeAlignment-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeAlignment</h4>
<pre>public&nbsp;void&nbsp;writeAlignment(int&nbsp;length)
                    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes the <code>0x00</code> alignment for the specified length. This padding is calculated as
 <code>(4 - length) & 3</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>length</code> - The length of the previously written buffer to pad</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="writeZeroPadding-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeZeroPadding</h4>
<pre>public&nbsp;void&nbsp;writeZeroPadding(int&nbsp;length)
                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes zero padding of the specified length</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>length</code> - Length to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the underlying output stream</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writePadding-int-int-"><code>writePadding(int, int)</code></a></dd>
</dl>
</li>
</ul>
<a name="writeSpacePadding-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeSpacePadding</h4>
<pre>public&nbsp;void&nbsp;writeSpacePadding(int&nbsp;length)
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes space (<code>0x20</code>) padding of the specified length</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>length</code> - Length to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the underlying output stream</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writePadding-int-int-"><code>writePadding(int, int)</code></a></dd>
</dl>
</li>
</ul>
<a name="writePadding-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writePadding</h4>
<pre>public&nbsp;void&nbsp;writePadding(int&nbsp;length,
                         int&nbsp;padByte)
                  throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes padding for the specified length of the specified padding byte.
 <p>
 Prefer using the more specific <a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeZeroPadding-int-"><code>writeZeroPadding(int)</code></a> and <a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeZeroPadding-int-"><code>writeZeroPadding(int)</code></a>.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>length</code> - Length of padding to write</dd>
<dd><code>padByte</code> - Padding byte to use</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the underlying output stream</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeSpacePadding-int-"><code>writeSpacePadding(int)</code></a>, 
<a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#writeZeroPadding-int-"><code>writeZeroPadding(int)</code></a></dd>
</dl>
</li>
</ul>
<a name="writeBuffer-byte:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeBuffer</h4>
<pre>public&nbsp;void&nbsp;writeBuffer(byte[]&nbsp;buffer)
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write a <code>byte</code> buffer to the underlying output stream in
 XDR format.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>buffer</code> - The <code>byte</code> buffer to be written</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="writeString-java.lang.String-org.firebirdsql.encodings.Encoding-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeString</h4>
<pre>public&nbsp;void&nbsp;writeString(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;s,
                        <a href="../../../../../org/firebirdsql/encodings/Encoding.html" title="interface in org.firebirdsql.encodings">Encoding</a>&nbsp;encoding)
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write content of the specified string using the specified encoding.</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code></dd>
</dl>
</li>
</ul>
<a name="writeTyped-int-org.firebirdsql.gds.impl.wire.Xdrable-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeTyped</h4>
<pre>public&nbsp;void&nbsp;writeTyped(int&nbsp;type,
                       <a href="../../../../../org/firebirdsql/gds/impl/wire/Xdrable.html" title="interface in org.firebirdsql.gds.impl.wire">Xdrable</a>&nbsp;item)
                throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write an <code>Xdrable</code> to this output stream.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>type</code> - Type of the <code>Xdrable</code> to be written,
        e.g. <a href="../../../../../org/firebirdsql/gds/ISCConstants.html#isc_tpb_version3"><code>ISCConstants.isc_tpb_version3</code></a></dd>
<dd><code>item</code> - The object to be written</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="writeTyped-org.firebirdsql.gds.ParameterBuffer-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeTyped</h4>
<pre>public&nbsp;void&nbsp;writeTyped(<a href="../../../../../org/firebirdsql/gds/ParameterBuffer.html" title="interface in org.firebirdsql.gds">ParameterBuffer</a>&nbsp;parameterBuffer)
                throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code></dd>
</dl>
</li>
</ul>
<a name="writeLong-long-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeLong</h4>
<pre>public&nbsp;void&nbsp;writeLong(long&nbsp;v)
               throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write a <code>long</code> value to the underlying stream in XDR format.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>v</code> - The <code>long</code> value to be written</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="writeInt-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeInt</h4>
<pre>public&nbsp;void&nbsp;writeInt(int&nbsp;v)
              throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write an <code>int</code> value to the underlying stream in XDR format.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>v</code> - The <code>int</code> value to be written</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="write-byte:A-int-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;void&nbsp;write(byte[]&nbsp;b,
                  int&nbsp;offset,
                  int&nbsp;len,
                  int&nbsp;pad)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write a <code>byte</code> buffer to the underlying output stream
 in XDR format.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>b</code> - The <code>byte</code> buffer to be written</dd>
<dd><code>offset</code> - The start offset in the buffer</dd>
<dd><code>len</code> - The number of bytes to write</dd>
<dd><code>pad</code> - The number of (blank) padding bytes to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="write-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;void&nbsp;write(int&nbsp;b)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Write a single <code>byte</code> to the underlying output stream in
 XDR format.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#write-int-" title="class or interface in java.io">write</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>b</code> - The value to be written, will be truncated to a byte</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="write-byte:A-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;void&nbsp;write(byte[]&nbsp;b,
                  int&nbsp;off,
                  int&nbsp;len)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes <code>len</code> bytes from the specified byte array
 starting at offset <code>off</code> to this output stream as defined by <a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#write-byte:A-int-int-" title="class or interface in java.io"><code>OutputStream.write(byte[], int, int)</code></a>.
 <p>
 <b>Important</b>: do not confuse this method with <a href="../../../../../org/firebirdsql/gds/impl/wire/XdrOutputStream.html#write-byte:A-int-int-int-"><code>write(byte[], int, int, int)</code></a> which originally had
 the signature of this method.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#write-byte:A-int-int-" title="class or interface in java.io">write</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>b</code> - The data</dd>
<dd><code>off</code> - The start offset in the data</dd>
<dd><code>len</code> - The number of bytes to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="flush--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>flush</h4>
<pre>public&nbsp;void&nbsp;flush()
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Flush all buffered data to the underlying output stream.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Flushable.html?is-external=true#flush--" title="class or interface in java.io">flush</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Flushable.html?is-external=true" title="class or interface in java.io">Flushable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#flush--" title="class or interface in java.io">flush</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while writing to the
         underlying output stream</dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Close this stream and the underlying output stream.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Closeable.html?is-external=true#close--" title="class or interface in java.io">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/Closeable.html?is-external=true" title="class or interface in java.io">Closeable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true#close--" title="class or interface in java.lang">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true#close--" title="class or interface in java.io">close</a></code>&nbsp;in class&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html?is-external=true" title="class or interface in java.io">OutputStream</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - if an error occurs while closing the
         underlying stream</dd>
</dl>
</li>
</ul>
<a name="setCipher-javax.crypto.Cipher-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setCipher</h4>
<pre>public&nbsp;void&nbsp;setCipher(<a href="https://docs.oracle.com/javase/8/docs/api/javax/crypto/Cipher.html?is-external=true" title="class or interface in javax.crypto">Cipher</a>&nbsp;cipher)
               throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code></dd>
</dl>
</li>
</ul>
<a name="writeDirect-byte:A-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>writeDirect</h4>
<pre>public final&nbsp;void&nbsp;writeDirect(byte[]&nbsp;data)
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></pre>
<div class="block">Writes directly to the <code>OutputStream</code> of the underlying socket.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>data</code> - Data to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/IOException.html?is-external=true" title="class or interface in java.io">IOException</a></code> - For errors writing to the socket.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/firebirdsql/gds/impl/wire/XdrInputStream.html" title="class in org.firebirdsql.gds.impl.wire"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/impl/wire/XdrOutputStream.html" target="_top">Frames</a></li>
<li><a href="XdrOutputStream.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
